<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/12/2008 *
 * ===============                              Last change: 23/12/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : debug.php                                        *
 * -------------------------------------------------------------------- *
 * Short description : Receiver script for debug.log files              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Empfangsscript fuer debug.log Dateien            *
 * -------------------------------------------------------------------- *
 * $Revision:: 856                                                    $ *
 * $Date:: 2009-03-06 20:24:32 +0100 (Fr, 06. Mär 2009)              $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author:: stelzi                                                   $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here (Oh, I hope this is not unsecure? Am I paranoia??? ;-) )
require("inc/libs/security_functions.php");

// Init "action" and "what"
$GLOBALS['what'] = "";
$GLOBALS['action'] = "";

// Set module and fake "CSS mode"
$GLOBALS['module'] = "debug";
$GLOBALS['output_mode'] = -1;

// Load the required file(s)
require("inc/config.php");

// Redirect only to registration page when this script is installed
if ((isInstalled()) && (getTotalFatalErrors() == 0)) {
	// Is the extension installed?
	if (!EXT_IS_ACTIVE("debug")) {
		// Then abort here
		shutdown();
	} // END - if

	// Is the request parameter set?
	if (REQUEST_ISSET_POST(('request'))) {
		// Handle the request
		if (DEBUG_HANDLE_REQUEST(REQUEST_POST('request'))) {
			// Construct FQFN for the module
			$INC = sprintf("inc/debug/%s/request_%s",
				getConfig('debug_mode'),
				SQL_ESCAPE(REQUEST_POST('request'))
			);

			// Is the module there? Else we log it!
			if (INCLUDE_READABLE($INC)) {
				// Load the request module
				LOAD_INC($INC);
			} else {
				// Missing request file, may happen while development
				DEBUG_ABUSE_LOG(__FILE__, __LINE__, "request_404", REQUEST_POST('request'));
			}
		} else {
			// Unhandled request detected
			DEBUG_ABUSE_LOG(__FILE__, __LINE__, "request_unhandled", REQUEST_POST('request'));
		}
	} else {
		// Empty request
		DEBUG_ABUSE_LOG(__FILE__, __LINE__, "request_empty", "");
	}
} else {
	// Not installed or fatal errors
	DEBUG_ABUSE_LOG(__FILE__, __LINE__, "request_fatal", getTotalFatalErrors());
} // END - if

// Really all done here... ;-)
shutdown();

//
?>
