<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/25/2003 *
 * ===============                              Last change: 11/24/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : header.php                                       *
 * -------------------------------------------------------------------- *
 * Short description : Outputs header HTML code, will not when frameset *
 *           is active                                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Gibt nur dann HTML-Code fuer den Kopf-Bereich    *
 *           aus, wenn Frameset nicht aktiv ist                         *
 * -------------------------------------------------------------------- *
 * $Revision:: 856                                                    $ *
 * $Date:: 2009-03-06 20:24:32 +0100 (Fr, 06. Mär 2009)              $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author:: stelzi                                                   $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Is the header already sent?
if (($GLOBALS['header_sent'] != "1") && ($GLOBALS['header_sent'] != "2")) {
	// If not in CSS mode generate the header
	if (($GLOBALS['output_mode'] != "1")) {
		// Generate header
		$TITLE = "";

		// Add title decorations? (left)
		if (!defined('__PAGE_TITLE')) {
			// Config and database connection valid?
			if ((isConfigLoaded()) && (SQL_IS_LINK_UP())) {
				// Title decoration enabled?
				if ((getConfig('enable_title_deco') == "Y") && (getConfig('title_left') != "")) $TITLE .= trim(getConfig('title_left'))." ";

				// Do we have some extra title?
				if (!empty($EXTRA_TITLE)) {
					// Then prepent it
					$TITLE .= $EXTRA_TITLE." by ";
				} // END - if

				// Add main title
				$TITLE .= constant('MAIN_TITLE');

				// Add title of module? (middle decoration will also be added!)
				if ((getConfig('enable_mod_title') == "Y") || ((empty($GLOBALS['what'])) && (empty($GLOBALS['action']))) || ($GLOBALS['module'] == "admin")) $TITLE .= " ".trim(getConfig('title_middle'))." ".ADD_MODULE_TITLE($GLOBALS['module']);

				// Add title from what file
				$MODE = "";
				if ($GLOBALS['module'] == "login") $MODE = "member";
				 elseif ($GLOBALS['module'] == "index") $MODE = "guest";
				if ((!empty($MODE)) && (getConfig('enable_what_title') == "Y")) $TITLE .= " ".trim(getConfig('title_middle'))." ".GET_MOD_DESCR($MODE, $GLOBALS['what']);

				// Add title decorations? (right)
				if ((getConfig('enable_title_deco') == "Y") && (getConfig('title_right') != "")) $TITLE .= " ".trim(getConfig('title_right'));

				// Remember title in constant for the template
				define('__PAGE_TITLE', $TITLE);
			} elseif ((!isInstalled()) || (!isAdminRegistered())) {
				// Installation mode
				define('__PAGE_TITLE', sprintf(getMessage('INSTALLATION_OF_MXCHANGE'), constant('MAIN_TITLE')));
			} else {
				// Configuration not found!
				define('__PAGE_TITLE', getMessage('NO_CONFIG_FOUND_TITLE'));

				// Do not add the fatal message in installation mode
				if (basename($_SERVER['PHP_SELF']) != "install.php") addFatalMessage(__FILE__, __LINE__, getMessage('NO_CONFIG_FOUND'));
			}
		} // END - if

		// Save some little memory
		unset($TITLE);

		// Output page header code
		LOAD_TEMPLATE("page_header");

		// Include meta data in "guest" module
		if ($GLOBALS['module'] == "index") {
			// Load meta data template
			LOAD_TEMPLATE("metadata");

			// Add meta description to header
			if ((isInstalled()) && (isAdminRegistered()) && (SQL_IS_LINK_UP())) {
				// Add meta description not in admin and login module and when the script is installed
				META_DESCRIPTION($GLOBALS['module'], $GLOBALS['what']);
			} // END - if
		} // END - if

		// Include more header data here
		LOAD_TEMPLATE("header");

		// Include stylesheet
		LOAD_INC_ONCE("inc/stylesheet.php");
	} // END - if

	// Closing HEAD tag
	if ($GLOBALS['output_mode'] != "1") OUTPUT_HTML("</head>");
	$GLOBALS['header_sent'] = 1;
} // END - if

// Load body or not
if (($GLOBALS['module'] != "frametester") || (($GLOBALS['module'] == "frametester") && (REQUEST_ISSET_GET(('frame')))) || (($GLOBALS['header_sent'] == "1") && (REQUEST_ISSET_GET(('frame')))) && ($GLOBALS['output_mode'] != "1")) {
	// Is the header sent and the script is not the mail confirmation script and not a CSS?
	if (($GLOBALS['header_sent'] == "1") && (basename($_SERVER['PHP_SELF']) != "mailid.php") && ($GLOBALS['output_mode'] != "1")) {
		// Add BODY tag
		LOAD_TEMPLATE("page_body");
		$GLOBALS['header_sent'] = 2;
	} // END - if
} // END - if

//
?>
