<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/24/2004 *
 * ===============                              Last change: 11/14/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : rewrite_functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Special functions for rewrite extension          *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Spezielle Funktion fuer rewrite-Erweiterung      *
 * -------------------------------------------------------------------- *
 * $Revision:: 856                                                    $ *
 * $Date:: 2009-03-06 20:24:32 +0100 (Fr, 06. Mär 2009)              $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author:: stelzi                                                   $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

//
function REWRITE_LINKS ($HTML) {
	// Skip rewriting for the admin area (which search engine may enter here???)
	if (ereg($GLOBALS['module'], getConfig('rewrite_skip'))) return $HTML;

	// Strip slashes with double-backslashes for the preg_replace() function
	$URL = str_replace("/", "\\/", constant('URL'));

	// Generate target URL
	$target = constant('URL')."/cms/";

	// Convert modules.php?module=...
	$test = preg_replace("/".$URL."\\/modules.php\\?module=/i", $target, $HTML);

	if (eregi(SERVER_URL, $test)) {
		// Konvert URLs from my server
		$URL = str_replace("/", "\\/", constant('SERVER_URL'));
		$test = preg_replace("/".$URL."\\/modules.php\\?module=/i", constant('SERVER_URL')."/cms/", $test);
	} // END - if

	// Strip slashes as above for the main URL
	$target2 = str_replace("/", "\\/", $target);

	// Action variable
	$act = $target."\$1/act/";

	// Convert &amp;|&action=...
	$test = preg_replace("/".$target2."(.*)&amp;action=/i", $act, $test);

	// "The same procedure as last variable"... now for &amp;what=
	$wht = $target."\$1/wht/";
	$target2 = str_replace("/", "\\/", $target);
	$test = preg_replace("/".$target2."(.*)&amp;what=/i", $wht, $test);

	if ((EXT_IS_ACTIVE("rallye")) && (eregi("rallye=", $test))) {
		// Replace data when rallye extension is active
		// Add more if you need more like these entries
		$REPLACE = array("rallye", "activate", "auto", "notify", "sub");
		foreach ($REPLACE as $var) {
			// This will replace "&amp;var=" to "/var/"
			$test = preg_replace("/&amp;".$var."=/i", "/".$var."/", $test);
		} // END - foreach
	} // END - if

	// Simple from->to replacements
	$REPLACE = array(
		'search'  => array("uid", "url", "page", "offset", "mid", "bid", "sub", "home"),
		'replace' => array("u"   , "url", "page", "offset", "m"  , "b"  , "s"  , "h")
	);

	if ((EXT_IS_ACTIVE("admins")) && (eregi("admin=", $test))) {
		// Replace &amp;admin= with "/aid/"
		$REPLACE['search'][]  = "admin";
		$REPLACE['replace'][] = "aid";
	} // END - if

	// Replace all array elements through
	foreach ($REPLACE['search'] as $k => $v) {
		if (eregi("$v=", $test)) {
			// Replace &amp;uid= with /u/
			$test = preg_replace("/&amp;".$v."=/i", "/".$REPLACE['replace'][$k]."/", $test);
		} // END - if
	} // END - foreach

	// Repair missed &amp;what=??? entries
	while (preg_match("/&amp;what=(.*)\/(.*)\/(.*)/i", $test)) {
		$test = preg_replace("/&amp;what=(.*)\/(.*)\/(.*)/i", "/wht/\$1/\$2/\$3", $test);
	} // END - while

	// Return rewritten code
	return $test;
}
//
?>
