<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/03/2004 *
 * ================                             Last change: 08/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_rallye_prices.php                    *
 * -------------------------------------------------------------------- *
 * Short description : Setup rallye prices                              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Rallye-Preise einrichten                         *
 * -------------------------------------------------------------------- *
 * $Revision:: 856                                                    $ *
 * $Date:: 2009-03-06 20:24:32 +0100 (Fr, 06. Mär 2009)              $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author:: stelzi                                                   $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

if (REQUEST_ISSET_GET(('rallye'))) {
	// Price submitted?
	if (REQUEST_ISSET_POST(('add'))) {
		if ((REQUEST_ISSET_POST(('level'))) && ((REQUEST_ISSET_POST(('points'))) || (REQUEST_ISSET_POST(('info'))))) {
			// Submitted data is valid, but maybe we already have this price level?
			$result = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_rallye_prices` WHERE rallye_id=%s AND price_level='%s' LIMIT 1",
				array(bigintval(REQUEST_GET('rallye')), bigintval(REQUEST_POST('level'))), __FILE__, __LINE__);

			if (SQL_NUMROWS($result) == 0) {
				// Ok, new price level entered!
				SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_rallye_prices` (rallye_id, price_level, points, info)
VALUES ('%s','%s','%s','%s')",
 array(
	bigintval(REQUEST_GET('rallye')),
	bigintval(REQUEST_POST('level')),
	REQUEST_POST('points'),
	REQUEST_POST('info')
), __FILE__, __LINE__);
				LOAD_TEMPLATE("admin_settings_saved", false, getMessage('RALLYE_PRICE_LEVEL_SAVED'));
			} else {
				// Free memory
				SQL_FREERESULT($result);

				// Price level found!
				LOAD_TEMPLATE("admin_settings_saved", false, getMessage('RALLYE_PRICE_ALREADY_FOUND'));
			}
		}
	} elseif (REQUEST_ISSET_POST(('remove'))) {
		// Check if at last one line is selected
		$SEL = SELECTION_COUNT(REQUEST_POST('sel'));
		if ($SEL > 0) {
			// Delete selected entries
			foreach (REQUEST_POST('sel') as $id => $sel) {
				SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_rallye_prices` WHERE id=%s LIMIT 1",
					array(bigintval($id)), __FILE__, __LINE__);
			}

			// Output message
			LOAD_TEMPLATE("admin_settings_saved", false, getMessage('RALLYE_ENTRIES_DELETED'));
		} else {
			LOAD_TEMPLATE("admin_settings_saved", false, getMessage('RALLYE_ENTRIES_NOT_DELETED'));
		}
	} elseif (REQUEST_ISSET_POST(('change'))) {
		// Change entries
		foreach (REQUEST_POST('level') as $id => $level) {
			// Secure ID
			$id = bigintval($id);

			// Update entry
			SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_rallye_prices` SET rallye_id=%s, price_level='%s', points='%s', info='%s' WHERE id=%s LIMIT 1",
				array(
					REQUEST_POST('rallye_id', $id),
					bigintval($level),
					REQUEST_POST('points', $id]),
					REQUEST_POST('infos', $id),
					$id
				), __FILE__, __LINE__);
		}

		// Output message
		LOAD_TEMPLATE("admin_settings_saved", false, getMessage('RALLYE_ENTRIES_CHANGED'));
	}

	if (REQUEST_ISSET_POST('edit')) {
		// Check if at last one line is selected
		$SEL = SELECTION_COUNT(REQUEST_POST('sel'));
		if ($SEL > 0) {
			// Make selected editable
			$OUT = ""; $SW = 2;
			foreach (REQUEST_POST('sel') as $id => $sel) {
				// Load data to selected rallye
				$result = SQL_QUERY_ESC("SELECT rallye_id, price_level, points, info FROM `{!_MYSQL_PREFIX!}_rallye_prices` WHERE id=%s LIMIT 1",
					array(bigintval($id)), __FILE__, __LINE__);
				list($rallye, $level, $points, $infos) = SQL_FETCHROW($result);
				SQL_FREERESULT($result);

				// Prepare data for the row template
				$content = array(
					'sw'      => $SW,
					'id'      => $id,
					'rallyes' => ADD_OPTION_LINES("rallye_data", "id", "title", $rallye),
					'level'   => $level,
					'points'  => $points,
					'infos'   => $infos,
				);

				// Load row template and switch color
				$OUT .= LOAD_TEMPLATE("admin_config_rallye_edit_row", true, $content);
				$SW = 3 - $SW;
			}
			define('__PRICE_ROWS', $OUT);

			// Prepare data for the main template
			define('__RALLYE_ID', REQUEST_GET('rallye'));

			// Load main template
			LOAD_TEMPLATE("admin_config_rallye_edit");
		} else {
			// Nothing selected
			$content = sprintf(getMessage('RALLYE_NO_PRICES_SELECTED'), "<a href=\"{!URL!}/modules.php?module=admin&amp;what=config_rallye_prices&amp;rallye=".REQUEST_GET('rallye')."\">", "</a>");
			LOAD_TEMPLATE("admin_settings_saved", false, $content);
		}
	} elseif (REQUEST_ISSET_POST('del')) {
		// Check if at last one line is selected
		$SEL = SELECTION_COUNT(REQUEST_POST('sel'));
		if ($SEL > 0) {
			// List all prices
			$OUT = ""; $SW = 2;
			foreach (REQUEST_POST('sel') as $id => $sel) {
				// Load data to selected rallye
				$result = SQL_QUERY_ESC("SELECT rallye_id, price_level, points, info FROM `{!_MYSQL_PREFIX!}_rallye_prices` WHERE id=%s LIMIT 1",
					array(bigintval($id)), __FILE__, __LINE__);
				list($rallye, $level, $points, $infos) = SQL_FETCHROW($result);
				SQL_FREERESULT($result);

				if (empty($infos)) $infos = "---";

				// Prepare data for the row template
				$content = array(
					'sw'      => $SW,
					'id'      => $id,
					'level'   => $level,
					'points'  => $points,
					'infos'   => $infos,
				);

				// Load row template and switch color
				$OUT .= LOAD_TEMPLATE("admin_config_rallye_del_row", true, $content);
				$SW = 3 - $SW;
			}
			define('__PRICE_ROWS', $OUT);

			// Prepare data for the main template
			define('__RALLYE_ID', REQUEST_GET('rallye'));

			// Load main template
			LOAD_TEMPLATE("admin_config_rallye_del");
		} else {
			// Nothing selected
			$content = RALLYE_NO_PRICES_SELECTED_1."<a href=\"{!URL!}/modules.php?module=admin&amp;what=config_rallye_prices&amp;rallye=".REQUEST_GET('rallye')."\">".RALLYE_NO_PRICES_SELECTED_2."</a>".RALLYE_NO_PRICES_SELECTED_3;
			LOAD_TEMPLATE("admin_settings_saved", false, $content);
		}
	} else {
		// a rallye was selected, so check if there are already prices assigned...
		$result = SQL_QUERY_ESC("SELECT id, price_level, points, info FROM `{!_MYSQL_PREFIX!}_rallye_prices` WHERE rallye_id=%s ORDER BY price_level",
			array(bigintval(REQUEST_GET('rallye'))), __FILE__, __LINE__);

		if (SQL_NUMROWS($result) > 0) {
			// Load all prices for the selected rallye
			$OUT = ""; $SW = 2;
			while ($content = SQL_FETCHARRAY($result)) {
				// Fix empty info
				if (empty($content['info'])) $content['info'] = "---";

				// Prepare data for the row template
				// @TODO Rewritings: level->price_level, infos->info in template
				$content = array(
					'sw'      => $SW,
					'id'      => $content['id'],
					'level'   => $content['price_level'],
					'points'  => $content['points'],
					'infos'   => $content['info'],
				);

				// Load row template and switch color
				$OUT .= LOAD_TEMPLATE("admin_config_rallye_prices_row", true, $content);
				$SW = 3 - $SW;
			} // END - while

			// Free memory
			SQL_FREERESULT($result);

			// @TODO Rewrite these two constants
			define('__PRICE_ROWS', $OUT);

			// Prepare data for the main template
			define('__RALLYE_ID', REQUEST_GET('rallye'));

			// Load main template
			LOAD_TEMPLATE("admin_config_rallye_prices");
		}
	}

	// Add form for adding new price level
	if (!REQUEST_ISSET_POST('edit')) {
		LOAD_TEMPLATE("admin_add_rallye_prices", false, REQUEST_GET('rallye'));
	}
} else {
	// No rallye selected so display all available without prices
	$result = SQL_QUERY("SELECT d.id, d.admin_id, d.start_time, d.end_time, d.title, a.login, d.is_active
FROM `{!_MYSQL_PREFIX!}_rallye_data` AS d, `{!_MYSQL_PREFIX!}_admins` AS a
WHERE d.admin_id=a.id ORDER BY start_time DESC", __FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// List found rallyes
		$OUT = ""; $SW = 2;
		while ($content = SQL_FETCHARRAY($result)) {
			$select = "<input type=\"checkbox\" name=\"sel[".$content['id']."]\" class=\"admin_normal\" value=\"1\">";
			if ($content['is_active'] == "Y") $select = "<div class=\"big\">".$content['id']."</div>";

			// Prepare data for the row template
			// @TODO Rewritings: aid->admin_id, alogin->login in template
			$content = array(
				'sw'         => $SW,
				'id'         => $content['id'],
				'select'     => $select,
				'title'      => $content['title'],
				'aid'        => $content['admin_id'],
				'email_link' => CREATE_EMAIL_LINK($content['admin_id']),
				'alogin'     => $content['login'],
				'start'      => MAKE_DATETIME($content['start_time'], "3"),
				'end'        => MAKE_DATETIME($content['end_time'], "3"),
			);

			// Load row template and switch color
			$OUT .= LOAD_TEMPLATE("admin_list_rallye_prices_row", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);
		define('__RALLYE_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE("admin_list_rallye_prices");
	} else {
		// No rallyes setup so far
		LOAD_TEMPLATE("admin_settings_saved", false, getMessage('RALLYE_NO_RALLYES_SETUP'));
	}
}
//
?>
