<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/09/2004 *
 * ================                             Last change: 10/31/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_unconfirmed.php                        *
 * -------------------------------------------------------------------- *
 * Short description : List unconfirmed mail links                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Unbest. Mail-Links auflisten                     *
 * -------------------------------------------------------------------- *
 * $Revision:: 856                                                    $ *
 * $Date:: 2009-03-06 20:24:32 +0100 (Fr, 06. Mär 2009)              $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author:: stelzi                                                   $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!EXT_IS_ACTIVE("mailid")) {
	addFatalMessage(__FILE__, __LINE__, getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), "mailid");
	return;
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

// Don't load the admin_list_unconfirmed template by default
$listed = false;

if (REQUEST_ISSET_GET(('mid'))) {
	// List confirmation links from your member's mail orders
	define('__LIST_UNCON_TITLE', getMessage('LIST_UNCONFIRMED_MEMBER_LINKS'));

	// SQL query for mail data
	$sql = "SELECT DISTINCT s.id, p.sender, p.subject, p.text, p.url, p.timestamp, s.max_rec  FROM `{!_MYSQL_PREFIX!}_pool` AS p
LEFT JOIN `{!_MYSQL_PREFIX!}_user_stats` AS s
ON p.id=s.pool_id
WHERE p.id='".REQUEST_GET('mid')."' LIMIT 1";

	// Column, type and ID for member's mail
	$col = "stats_id"; $type = "NORMAL"; $ID = "-1";

	// Load admin_list_unconfirmed template
	$listed = true; $DATA = REQUEST_GET('mid'); $LINK = "mailid";
} elseif ((REQUEST_ISSET_GET(('bid'))) && (EXT_IS_ACTIVE("bonus"))) {
	// List confirmation links from bonus mails
	define('__LIST_UNCON_TITLE', getMessage('LIST_UNCONFIRMED_BONUS_LINKS'));

	// SQL query for mail data (both ids are required for compatiblity to above normal mail
	$sql = "SELECT id, id, subject, text, url, timestamp, mails_sent FROM `{!_MYSQL_PREFIX!}_bonus` WHERE id='".REQUEST_GET('bid')."' LIMIT 1";

	// Column, type and ID for member's mail
	$col = "bonus_id"; $type = "BONUS"; $ID = REQUEST_GET('bid');

	// Load admin_list_unconfirmed template
	$listed = true; $DATA = $ID; $LINK = "bonusid";
} else {
	// "Please do not call me directly."
	LOAD_TEMPLATE("admin_settings_saved", false, getMessage('ADMIN_CALL_NOT_DIRECTLY'));
}

// Shall I display links or not?
if ($listed === true) {
	// Load mail data
	$result = SQL_QUERY($sql, __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Mail order / bonus mail found!
		// @TODO Rewrite this to $content = SQL_FETCHARRAY(), look some lines above for two differrent queries
		list($stats_id, $sender, $subj, $text, $url, $stamp, $max) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Transfer data to constants for the template
		if (($stats_id > 0) && ($ID == "-1")) $ID = $stats_id;
		if ($col == "bonus_id") $sender = 0;

		// @TODO Rewrite these constants
		define('__LIST_UNCON_SENDER' , $sender);
		define('__LIST_UNCON_SUBJECT', COMPILE_CODE($subj));
		define('__LIST_UNCON_TEXT'   , COMPILE_CODE($text));
		define('__LIST_UNCON_URL'    , encodeString($url));
		define('__LIST_UNCON_STAMP'  , MAKE_DATETIME($stamp, "2"));

		// Load unconfirmed mail links. Hmmm, this select query is pretty cool
		// but it does only show unconfirmed mail links from existing user
		// accounts. So if you have delete one you did not see those links
		//
		$result = SQL_QUERY_ESC("SELECT DISTINCT l.userid, u.status, u.surname, u.family, u.gender, u.email
FROM `{!_MYSQL_PREFIX!}_user_links` AS l
LEFT JOIN `{!_MYSQL_PREFIX!}_user_data` AS u
ON l.userid=u.userid
WHERE l.%s='%s' ORDER BY l.userid LIMIT %s",
			array($col, $ID, bigintval($max)),__FILE__, __LINE__);
		$unconfirmed = SQL_NUMROWS($result);

		// @TODO Rewrite this constant
		define('__LIST_UNCO_UNCONFIRMED', $unconfirmed);

		if ($unconfirmed > 0) {
			// At least one link left to confirm
			$OUT = LOAD_TEMPLATE("admin_list_unconfirmed_header", true);
			$SW = 2;
			while ($content = SQL_FETCHARRAY($result)) {
				// Prepare data for the row template
				// @TODO Rewritings: uid->userid
				$content = array(
					'sw'     => $SW,
					'u_link' => ADMIN_USER_PROFILE_LINK($content['userid']),
					'uid'    => $content['userid'],
					'link'   => $LINK,
					'id'     => $ID,
					'email'  => "<a href=\"".CREATE_EMAIL_LINK($content['email'], "user_data")."\">".TRANSLATE_GENDER($content['gender'])." ".$content['surname']." ".$content['family']."</a>",
					'status' => TRANSLATE_STATUS($content['status']),
				);

				// Load row template and switch colors
				$OUT .= LOAD_TEMPLATE("admin_list_unconfirmed_row", true, $content);
				$SW = 3 - $SW;
			}
			$OUT .= "</table>\n";

			// Free memory
			SQL_FREERESULT($result);

			// Store table rows in a constant
			define('__LIST_UNCON_LISTING', $OUT);
		} else {
			// All links are confirmed... strange, you shall normally not get a link to this place in this scenario... hmmm.
			define('__LIST_UNCON_LISTING', LOAD_TEMPLATE("admin_settings_saved", true, getMessage('ADMIN_UNCONFIRMED_NO_LINK_LEFT')));
		}

		// Load final template
		LOAD_TEMPLATE("admin_list_unconfirmed");
	} elseif (REQUEST_GET('mid') > 0) {
		// Data in pool or in user_stats not found, so let's find out where data is missing
		$result1 = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_pool` WHERE id=%s LIMIT 1",
			array(bigintval($ID)), __FILE__, __LINE__);
		$result2 = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_user_stats` WHERE pool_id=%s LIMIT 1",
			array(bigintval($ID)), __FILE__, __LINE__);
		if (SQL_NUMROWS($result1) == 1) {
			// pool table
			LOAD_TEMPLATE("admin_settings_saved", false, sprintf(getMessage('ADMIN_UNCONFIRMED_POOL_MISSING', $ID)));
		} elseif (SQL_NUMROWS($result2) == 1) {
			// user_stats table
			LOAD_TEMPLATE("admin_settings_saved", false, sprintf(getMessage('ADMIN_UNCONFIRMED_STATS_MISSING', $ID)));
		} else {
			// both or link is invalid
			LOAD_TEMPLATE("admin_settings_saved", false, getMessage('ADMIN_UNCONFIRMED_INVALID_LINK'));
		}

		// Free memory
		SQL_FREERESULT($result1);
		SQL_FREERESULT($result2);
	} elseif (REQUEST_ISSET_GET(('bid'))) {
		// Data in bonus table not found
		LOAD_TEMPLATE("admin_settings_saved", false, getMessage('ADMIN_UNCONFIRMED_INVALID_LINK'));
	}
}

//
?>
