<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/19/2003 *
 * ===============                              Last change: 07/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-refbanner.php                               *
 * -------------------------------------------------------------------- *
 * Short description : Manage all referal banner                        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle Banner fuer die Ref-Links verwalten         *
 * -------------------------------------------------------------------- *
 * $Revision:: 856                                                    $ *
 * $Date:: 2009-03-06 20:24:32 +0100 (Fr, 06. Mär 2009)              $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author:: stelzi                                                   $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", __FILE__);

// Init variable
$SEL = 0;

// Some sanity-check
if ((!REQUEST_ISSET_POST(('url'))) || (!REQUEST_ISSET_POST(('alternate')))) {
	REQUEST_UNSET_POST('ok');
}

// Check selection count
if (REQUEST_ISSET_POST('sel')) $SEL = SELECTION_COUNT(REQUEST_POST('sel'));

if (IS_FORM_SENT()) {
	// Fix older calls from add-new-banner-form
	if (!REQUEST_ISSET_GET(('mode'))) REQUEST_SET_GET('mode', "add");
	$sql = "";
	switch (REQUEST_GET('mode'))
	{
	case "add":
		// Check if banner is already added
		$result = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_refbanner` WHERE url='%s' LIMIT 1",
			array(REQUEST_POST('url')), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 0) {
			// Add banner
			SQL_QUERY_ESC("INSERT INTO `{!_MYSQL_PREFIX!}_refbanner` (url, alternate, visible)
VALUES ('%s','%s','%s')",
				array(REQUEST_POST('url'), REQUEST_POST('alternate'), REQUEST_POST('visible')), __FILE__, __LINE__);
		} else {
			// Free memory
			SQL_FREERESULT($result);
		}
		break;

	case "edit": // Update banner
		foreach (REQUEST_POST('sel') as $id => $sel) {
			// Secure ID
			$id = bigintval($id);

			// Update entry
			SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_refbanner` SET url='%s', alternate='%s', `visible`='%s' WHERE id=%s LIMIT 1",
				array(
					REQUEST_POST('url', $id),
					REQUEST_POST('alternate', $id),
					REQUEST_POST('visible'),
					$id
				), __FILE__, __LINE__);
		}
		break;
	}

	if (SQL_AFFECTEDROWS() == 1) {
		$content = getMessage('SETTINGS_SAVED');
	} else {
		$content = "<span class=\"admin_failed\">{--SETTINGS_NOT_SAVED--}</span>";
	}
	LOAD_TEMPLATE("admin_settings_saved", false, $content);
} elseif (($SEL > 0) && (REQUEST_ISSET_POST('edit'))) {
	// Edit banner
	$SW = ""; $OUT = "";
	foreach (REQUEST_POST('sel') as $id => $sel) {
		// Load data
		$result = SQL_QUERY_ESC("SELECT url, alternate, visible FROM `{!_MYSQL_PREFIX!}_refbanner` WHERE id=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
		list($url, $alt, $vis) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Preapre data for the row
		$content = array(
			'sw'  => $SW,
			'id'  => $id,
			'url' => $url,
			'alt' => $alt,
			'vis' => ADD_SELECTION("yn", $vis   , "visible"),
		);

		// Load row template and switch color
		$OUT .= LOAD_TEMPLATE("admin_refbanner_edit_row", true, $content);
		$SW = 3 - $SW;
	}

	// @TODO Rewrite this constant
	define('__BANNER_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE("admin_refbanner_edit");
} else {
	if (($SEL > 0) && (REQUEST_ISSET_POST('del'))) {
		// Delete banner
		foreach (REQUEST_POST('sel') as $id => $sel) {
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_refbanner` WHERE id=%s LIMIT 1",
				array(bigintval($id)), __FILE__, __LINE__);
		}
	}

	// Referal levels
	$result = SQL_QUERY("SELECT id, url, alternate, visible, counter, clicks FROM `{!_MYSQL_PREFIX!}_refbanner` ORDER BY url",
		__FILE__, __LINE__);
	if (SQL_NUMROWS($result) > 0) {
		// Make referal banner editable and deletable
		$OUT = ""; $SW = 2;
		while ($content = SQL_FETCHARRAY($result)) {
			// Preapre data for the row
			// @TODO Rewritings: alt->alternate,cnt->counter,clx->clicks in template
			$content = array(
				'sw'  => $SW,
				'id'  => $content['id'],
				'url' => $content['url'],
				'alt' => $content['alternate'],
				'vis' => TRANSLATE_YESNO($content['visible']),
				'cnt' => $content['counter'],
				'clx' => $content['clicks']
			);

			// Load row template and switch color
			$OUT .= LOAD_TEMPLATE("admin_refbanner_row", true, $content);
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result);

		// @TODO Rewrite this constant
		define('__BANNER_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE("admin_refbanner");
	}

	// Form for adding new referal levels
	LOAD_TEMPLATE("admin_add_banner");
}

//
?>
