<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/18/2005 *
 * ===============                              Last change: 03/18/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : stats_bonus.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Check for 100% clickrate order                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Nach Mailbestaetigungen mit 100% Klickrate s.    *
 * -------------------------------------------------------------------- *
 * $Revision:: 856                                                    $ *
 * $Date:: 2009-03-06 20:24:32 +0100 (Fr, 06. Mär 2009)              $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author:: stelzi                                                   $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Check for 100% klickrate mails
$result_bonus = SQL_QUERY("SELECT id, userid, subject, timestamp_ordered, clicks, url
FROM `{!_MYSQL_PREFIX!}_user_stats`
WHERE max_rec=clicks AND clicks>0 AND bonus_stats_active='N'
ORDER BY userid", __FILE__, __LINE__);

if (SQL_NUMROWS($result_bonus) > 0) {
	// Remember stats bonus in constant
	define('__STATS_BONUS', TRANSLATE_COMMA(getConfig('bonus_stats')));

	// We found some mail orders...
	while ($content = SQL_FETCHARRAY($result_bonus)) {
		// Add points
		SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET bonus_stats=bonus_stats+%s WHERE userid=%s LIMIT 1",
			array(getConfig('bonus_stats'), bigintval($content['userid'])), __FILE__, __LINE__);

		// Translate some data
		$content['timestamp'] MAKE_DATETIME($content['timestamp_ordered'], "2");

		// Load email template and send email
		$msg = LOAD_EMAIL_TEMPLATE("member_stats_bonus", $content, bigintval($content['userid']));
		SEND_EMAIL($content['userid'], getMessage('BONUS_MEMBER_STATS_SUBJECT'), $msg);

		// Update database
		$result_update = SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_stats` SET bonus_stats_active='Y' WHERE id=%s LIMIT 1",
			array(bigintval($content['id'])), __FILE__, __LINE__);
	} // END - while

	// Handle bonus points
	BONUS_POINTS_HANDLER(getConfig('bonus_stats'));
}

// Free memory
SQL_FREERESULT($result_bonus);

//
?>
