<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 05/14/2007 *
 * ===============                              Last change: 05/14/2007 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : lead-confirm.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Script for lead-campaign codes                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alles um den Bestaetigungslink                   *
 * -------------------------------------------------------------------- *
 * $Revision:: 856                                                    $ *
 * $Date:: 2009-03-06 20:24:32 +0100 (Fr, 06. Mär 2009)              $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author:: stelzi                                                   $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here (Oh, I hope this is not unsecure? Am I paranoia??? ;-) )
require("inc/libs/security_functions.php");

// Init "action" and "what"
$GLOBALS['startTime'] = microtime(true);
$GLOBALS['what'] = "";
$GLOBALS['action'] = "";

// Set module
$GLOBALS['module'] = "lead-confirm";

// Set "CSS-Mode"
$GLOBALS['output_mode'] = "0";

// Load config.php
require("inc/config.php");

// Is the script installed?
if (isInstalled()) {
	// Header
	LOAD_INC("inc/header.php");

	// Initialize the array for the template
	$content = array(
		'lead_uid'   => -1,
		'lead_email' => "INVALID@EMAIL"
	);

	// Is the cookie set?
	if (isSessionVariableSet('lead_uid')) {
		// Is the user-account unlocked and valid?
		$result = SQL_QUERY_ESC("SELECT email FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s AND `status`='CONFIRMED' LIMIT 1",
			array(bigintval(get_session('lead_uid'))), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Secure the ID number
			$content['lead_uid'] = bigintval(get_session('lead_uid'));

			// Load the email address
			list($email) = SQL_FETCHROW($result);

			// Compile email
			$content['lead_email'] = COMPILE_CODE($email);
		} else {
			// Not found!
			$content['lead_uid'] = 0;
		}
	} else {
		// Maybe spider?
		$content['lead_email'] = constant('WEBMASTER');
	}

	// Load the lead template
	LOAD_TEMPLATE("lead_code", false, $content);

	// Footer
	LOAD_INC("inc/footer.php");
} else {
	// You have to install first!
	LOAD_URL("install.php");
}

// All done here...
shutdown();

//
?>
